image: docker:stable

variables:
  # When using dind service we need to instruct docker, to talk with the
  # daemon started inside of the service. The daemon is available with
  # a network connection instead of the default /var/run/docker.sock socket.
  #
  # The 'docker' hostname is the alias of the service container as described at
  # https://docs.gitlab.com/ee/ci/docker/using_docker_images.html#accessing-the-services
  #
  # Note that if you're using Kubernetes executor, the variable should be set to
  # tcp://localhost:2375 because of how Kubernetes executor connects services
  # to the job container
  DOCKER_HOST: tcp://docker:2375/
  # When using dind, it's wise to use the overlayfs driver for
  # improved performance.
  DOCKER_DRIVER: overlay2
  CONTAINER_IMAGE: $CI_REGISTRY/$CI_PROJECT_PATH
  CONTAINER_TEST_IMAGE: $CI_REGISTRY/$CI_PROJECT_PATH:$CI_COMMIT_REF_SLUG
  CONTAINER_RELEASE_IMAGE: $CI_REGISTRY/$CI_PROJECT_PATH:latest
  DOCKER_CLI_EXPERIMENTAL: enabled

services:
  - name: docker:dind
    command: ["--experimental"]

stages:
  - build64
  - build32
  - release

build64:
  tags:
    - docker
  stage: build64
  script:
    - docker build -f Dockerfile-arm64 --build-arg registry=$REGISTRY --tag $CONTAINER_IMAGE:${CI_COMMIT_SHA}_arm64 --tag ${CONTAINER_TEST_IMAGE}_arm64 .
    - docker push $CONTAINER_IMAGE:${CI_COMMIT_SHA}_arm64
    - docker push ${CONTAINER_TEST_IMAGE}_arm64
  only:
    changes:
      - .gitlab-ci.yml
      - Dockerfile-arm64

build32:
  tags:
    - docker
  stage: build32
  script:
    - docker build -f Dockerfile-armhf --build-arg registry=$REGISTRY --tag $CONTAINER_IMAGE:${CI_COMMIT_SHA}_arm --tag ${CONTAINER_TEST_IMAGE}_arm .
    - docker push $CONTAINER_IMAGE:${CI_COMMIT_SHA}_arm
    - docker push ${CONTAINER_TEST_IMAGE}_arm
  only:
    changes:
      - .gitlab-ci.yml
      - Dockerfile-armhf
      - stats_linux.go
      - atomic.go
    
release-image:
  tags:
    - docker
  stage: release
  script:
    - docker pull ${CONTAINER_TEST_IMAGE}_arm64
    - docker pull ${CONTAINER_TEST_IMAGE}_arm
    - docker tag ${CONTAINER_TEST_IMAGE}_arm64 ${CONTAINER_RELEASE_IMAGE}_arm64
    - docker tag ${CONTAINER_TEST_IMAGE}_arm ${CONTAINER_RELEASE_IMAGE}_arm
    - docker manifest create ${CONTAINER_RELEASE_IMAGE} ${CONTAINER_TEST_IMAGE}_arm64 ${CONTAINER_TEST_IMAGE}_arm
    - docker manifest annotate ${CONTAINER_RELEASE_IMAGE} ${CONTAINER_TEST_IMAGE}_arm64 --os linux --arch arm64
    - docker manifest annotate ${CONTAINER_RELEASE_IMAGE} ${CONTAINER_TEST_IMAGE}_arm --os linux --arch arm
    - docker manifest push ${CONTAINER_RELEASE_IMAGE}
  only:
    - master

before_script:
  - echo "$CI_REGISTRY_PASSWORD" | docker login -u "$CI_REGISTRY_USER" --password-stdin $CI_REGISTRY
